net.sf.cpsolver.coursett.criteria.additional

## Class RoomSizePenalty

- java.lang.Object
- - net.sf.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - net.sf.cpsolver.coursett.criteria.TimetablingCriterion
    - - net.sf.cpsolver.coursett.criteria.additional.RoomSizePenalty

- All Implemented Interfaces:
    Criterion<Lecture,Placement>, InfoProvider<Lecture>, ModelListener<Lecture,Placement>

      public class RoomSizePenalty
      extends TimetablingCriterion

  Cost for using room(s) that are too big. I.e., a difference between size of the assigned room and the size of the smallest room in which the class can be placed `Lecture.minRoomSize()`.
  A weight for room size penalty can be set by problem property Comparator.RoomSizeWeight.
  The difference function can be made polynomial by using Comparator.RoomSizeFactor parameter (defaults to 1.05). The value of this criteria is then cubed by the power of this room size factor. This is to be able to favor a room swap between two classes at the same time, in which a smaller class takes a smaller room. To do this, set Comparator.RoomSizeFactor to a number bigger than one that is close to one (e.g., 1.05).
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2013 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iValue, iValueUpdateType, iWeight, sDoubleFormat, sPercentFormat`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RoomSizePenalty()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `getInfo(Map<String,String> info)` Adds some information into the table with information about the solution
    `String` | `getPlacementSelectionWeightName()`
    `double` | `getValue(Placement value, Set<Placement> conflicts)` Value of a proposed assignment (including hard conflicts)
    `double` | `getWeightDefault(DataProperties config)` Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
    `boolean` | `init(Solver<Lecture,Placement> solver)` Notification that the model was initialized by the solver.

    - ### Methods inherited from class net.sf.cpsolver.coursett.criteria.TimetablingCriterion

      `getAbbreviation, getPlacementSelectionWeight, getPlacementSelectionWeightDefault, toString`

    - ### Methods inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestRestored, bestSaved, clearCache, computeBounds, constraintAdded, constraintRemoved, getBest, getBounds, getBounds, getInfo, getModel, getName, getPerc, getPercRev, getValue, getValue, getWeight, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RoomSizePenalty

          public RoomSizePenalty()

  - ### Method Detail

    - #### init

          public boolean init(Solver<Lecture,Placement> solver)

      Description copied from interface: `ModelListener`
      Notification that the model was initialized by the solver.
      Specified by:
        `init` in interface `ModelListener<Lecture,Placement>`
      Overrides:
        `init` in class `TimetablingCriterion`
      Parameters:
        `solver` - IFS solver

    - #### getWeightDefault

          public double getWeightDefault(DataProperties config)

      Description copied from class: `AbstractCriterion`
      Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
      Overrides:
        `getWeightDefault` in class `AbstractCriterion<Lecture,Placement>`

    - #### getPlacementSelectionWeightName

          public String getPlacementSelectionWeightName()

      Overrides:
        `getPlacementSelectionWeightName` in class `TimetablingCriterion`

    - #### getValue

          public double getValue(Placement value,
                                 Set<Placement> conflicts)

      Description copied from interface: `Criterion`
      Value of a proposed assignment (including hard conflicts)

    - #### getInfo

          public void getInfo(Map<String,String> info)

      Description copied from interface: `InfoProvider`
      Adds some information into the table with information about the solution
      Specified by:
        `getInfo` in interface `InfoProvider<Lecture>`
      Overrides:
        `getInfo` in class `AbstractCriterion<Lecture,Placement>`